Description

An example of a non-graceful error:

# ceph nfs cluster config reset morbo -i /tmp/g 

Error EINVAL: Traceback (most recent call last):

  File "/usr/share/ceph/mgr/mgr_module.py", line 1448, in _handle_command

    return CLICommand.COMMANDS[cmd['prefix']].call(self, cmd, inbuf)

  File "/usr/share/ceph/mgr/mgr_module.py", line 414, in call

    return self.func(mgr, **kwargs)

TypeError: _cmd_nfs_cluster_config_reset() got an unexpected keyword argument 'inbuf'

 

Also seen at:

https://tracker.ceph.com/issues/48663

https://tracker.ceph.com/issues/49790

This is a generic issue with how the ceph cli command and mgr module argument mapper handles the `-i` option specially. It should

not be particularly challenging to convert this into a more pleasant and understandable error such as:

"Invalid command: Input file data (-i) not supported"

mimicking the case where an extra regular arg is passed to a cli:

# ceph nfs cluster create    foobar --quux=yes

Invalid command: Unexpected argument '--quux=yes'

nfs cluster create <cluster_id> [<placement>] [--ingress] [<virtual_ip>] [<port:int>] :  Create an

 NFS Cluster

Error EINVAL: invalid command

Related issues:

Copied to mgr - Backport #59634: reef: Commands that don't take inbuf should ... Resolved

History

#1 - 04/12/2023 05:40 PM - John Mulligan

- Pull request ID set to 50976

#2 - 05/03/2023 09:30 PM - Adam King

- Status changed from New to Pending Backport

- Backport set to reef

#3 - 05/03/2023 09:30 PM - Backport Bot
- Copied to Backport #59634: reef: Commands that don't take inbuf should error out gracefully added
- Tags set to backport_processed

#5 - 05/23/2023 12:33 PM - Adam King

- Status changed from Pending Backport to Resolved
